io.vertx.reactivex.ext.web.handler.sockjs

## Class SockJSSocket

- java.lang.Object
- - io.vertx.reactivex.ext.web.handler.sockjs.SockJSSocket

- All Implemented Interfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class SockJSSocket
      extends Object
      implements ReadStream<Buffer>, WriteStream<Buffer>

  You interact with SockJS clients through instances of SockJS socket.

  The API is very similar to `WebSocket`. It implements both and so it can be used with `Pump` to pump data with flow control.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<SockJSSocket>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SockJSSocket(SockJSSocket delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close it
    `void` | `close(int statusCode, String reason)` Close it giving a status code and reason.
    `SockJSSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Call `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`.
    `void` | `end(Buffer data)` Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but writes some data to the stream before ending.
    `void` | `end(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `void` | `end(Handler<AsyncResult<Void>> handler)` Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `SockJSSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `boolean` | `equals(Object o)`
    `SockJSSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `ReadStream<Buffer>` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `SockJSSocket` | `getDelegate()`
    `SockJSSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `int` | `hashCode()`
    `MultiMap` | `headers()` Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
    `SocketAddress` | `localAddress()` Return the local address for this socket
    `static SockJSSocket` | `newInstance(SockJSSocket arg)`
    `SockJSSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` Pause this stream and return a to transfer the elements of this stream to a destination .
    `void` | `pipeTo(WriteStream<Buffer> dst)` Like `ReadStream.pipeTo(io.vertx.reactivex.core.streams.WriteStream<T>)` but with no completion handler.
    `void` | `pipeTo(WriteStream<Buffer> dst, Handler<AsyncResult<Void>> handler)` Pipe this `ReadStream` to the `WriteStream`.
    `SocketAddress` | `remoteAddress()` Return the remote address for this socket
    `SockJSSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `Completable` | `rxEnd()` Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxEnd(Buffer data)` Same as but with an `handler` called when the operation completes
    `Completable` | `rxPipeTo(WriteStream<Buffer> dst)` Pipe this `ReadStream` to the `WriteStream`.
    `Completable` | `rxWrite(Buffer data)`
    `SockJSSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `Flowable<Buffer>` | `toFlowable()`
    `Observable<Buffer>` | `toObservable()`
    `io.vertx.reactivex.WriteStreamObserver<Buffer>` | `toObserver()`
    `String` | `toString()`
    `io.vertx.reactivex.WriteStreamSubscriber<Buffer>` | `toSubscriber()`
    `String` | `uri()` Return the URI corresponding to the last request for this socket or the websocket handshake
    `Session` | `webSession()`
    `User` | `webUser()`
    `SockJSSocket` | `write(Buffer data)` Write some data to the stream.
    `SockJSSocket` | `write(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `SockJSSocket` | `write(String data)` Write a `String` to the socket, encoded in UTF-8.
    `SockJSSocket` | `write(String data, Handler<AsyncResult<Void>> handler)`
    `String` | `writeHandlerID()` When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.ReadStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<SockJSSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### SockJSSocket

          public SockJSSocket(SockJSSocket delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public SockJSSocket getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toFlowable

          public Flowable<Buffer> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<Buffer>`

    - #### toObserver

          public io.vertx.reactivex.WriteStreamObserver<Buffer> toObserver()

    - #### toSubscriber

          public io.vertx.reactivex.WriteStreamSubscriber<Buffer> toSubscriber()

    - #### end

          public void end(Handler<AsyncResult<Void>> handler)

      Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` -

    - #### rxEnd

          public Completable rxEnd()

      Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Returns:

    - #### end

          public void end(Buffer data)

      Same as `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write

    - #### end

          public void end(Buffer data,
                          Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -

    - #### rxEnd

          public Completable rxEnd(Buffer data)

      Same as but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### fetch

          public ReadStream<Buffer> fetch(long amount)

      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Parameters:
        `amount` -
      Returns:
        a reference to this, so the API can be used fluently

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst)

      Like `ReadStream.pipeTo(io.vertx.reactivex.core.streams.WriteStream<T>)` but with no completion handler.
      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` -

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst,
                             Handler<AsyncResult<Void>> handler)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
        `handler` -

    - #### rxPipeTo

          public Completable rxPipeTo(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Parameters:
        `dst` - the destination write stream
      Returns:

    - #### exceptionHandler

          public SockJSSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public SockJSSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public SockJSSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public SockJSSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public SockJSSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public SockJSSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public SockJSSocket write(String data)

      Write a `String` to the socket, encoded in UTF-8.
      Parameters:
        `data` - the string to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public SockJSSocket write(String data,
                                    Handler<AsyncResult<Void>> handler)

    - #### write

          public SockJSSocket write(Buffer data,
                                    Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WriteStream`
      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Returns:

    - #### rxWrite

          public Completable rxWrite(Buffer data)

    - #### setWriteQueueMaxSize

          public SockJSSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public SockJSSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          public String writeHandlerID()

      When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying socket. This allows you to write data to other sockets which are owned by different event loops.

      Returns:

    - #### end

          public void end()

      Call `end(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          public void close()

      Close it

    - #### close

          public void close(int statusCode,
                            String reason)

      Close it giving a status code and reason. Only Applicable to RawWebSocket will downgrade to plain close for other transports.
      Parameters:
        `statusCode` -
        `reason` -

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Return the remote address for this socket
      Returns:

    - #### localAddress

          public SocketAddress localAddress()

      Return the local address for this socket
      Returns:

    - #### headers

          public MultiMap headers()

      Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
      Returns:

    - #### uri

          public String uri()

      Return the URI corresponding to the last request for this socket or the websocket handshake
      Returns:

    - #### webSession

          public Session webSession()

      Returns:
        the Vert.x-Web session corresponding to this socket

    - #### webUser

          public User webUser()

      Returns:
        the Vert.x-Web user corresponding to this socket

    - #### newInstance

          public static SockJSSocket newInstance(SockJSSocket arg)

Copyright © 2019 Eclipse. All rights reserved.